/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

struct komand
{
    int kom, x, y, num;

    komand()
    {
        kom = 0;
        x = 0;
        y = 0;
        num = 0;
    }

    komand(int a, int b)
    {
        kom = a;
        x = 0;
        y = 0;
        num = b;
    }

    komand(int a, int b, int c, int d)
    {
        kom = a;
        x = b;
        y = c;
        num = d;
    }
};

vector <komand> v;
const int cons = 600;
const int cons1 = 600;
pair <int, int> c[50010];
int i, j, otv, a[1220][1220], b[1220][1220], x, y;
bool flag = false;

void proc1()
{
    for(i = 0; i <= 50000; i++)
        c[i] = mp(-10000, -10000);

    for(i = 0; i < 1220; i++)
        for(j = 0; j < 1220; j++)
            a[i][j] = b[i][j] = 0;

    flag = true;
}

void proc2()
{
    for(i = 0; i < v.size(); i++)
        if(v[i].kom == 1)
        {
            c[v[i].num] = mp(v[i].x, v[i].y);
            a[v[i].x][v[i].y]++;
        }
        else
        {
            c[v[i].num] = mp(-10000, -10000);
            a[v[i].x][v[i].y]--;
        }

    for(i = 1; i <= 1201; i++)
        for(j = 1; j <= 1201; j++)
            b[i][j] = a[i][j] + b[i][j - 1] + b[i - 1][j] - b[i - 1][j - 1];

    v.clear();
}

void addSoldier(int x, int y, int s)
{
    if(flag == false)
        proc1();

    v.push_back(komand(1, x + y + cons + 1, - x + y + cons + 1, s));

    if(v.size() == cons1)
        proc2();
}

int removeSoldier(int s)
{
    if(flag == false)
        proc1();

    x = c[s].X;
    y = c[s].Y;

    for(i = 0; i < v.size(); i++)
        if(v[i].num == s)
        {
            if(v[i].kom == 1)
            {
                x = v[i].x;
                y = v[i].y;
            }
            else
            {
                x = -10000;
                y = -10000;
            }
        }

    if(x != -10000)
    {
        v.push_back(komand(2, x, y, s));
        if(v.size() == cons1)
            proc2();
        return 1;
    }
    else
        return 0;
}

int query(int x, int y, int d)
{
    if(flag == false)
        proc1();

    x = x + y;
    y = - x + y + y;
    x += cons + 1;
    y += cons + 1;

    otv = b[min(x + d, 1201)][min(y + d, 1201)]
        - b[min(x + d, 1201)][max(y - d - 1,0)]
        - b[max(x - d - 1,0)][min(y + d, 1201)]
        + b[max(x - d - 1,0)][max(y - d - 1,0)];

    for(i = 0; i < v.size(); i++)
        if(v[i].x <= x + d &&
           v[i].x >= x - d &&
           v[i].y <= y + d &&
           v[i].y >= y - d)
        {
            if(v[i].kom == 1)
                otv++;
            else
                otv--;
        }

    return otv;
}














