/* GCC */
#include <algorithm>
#include <iostream>
using namespace std;

int a[1201][1201];
pair<int,int> w[50001];
inline void add(int x,int y,int c)
{
	x+=600; y+=600;
	for (int i=x;i<=1200;i|=i+1)
		for (int j=y;j<=1200;j|=j+1)
			a[i][j]+=c;
}
inline int sum(int x,int y)
{
	if (x<-600) x=-600;
	if (x>600) x=600;
	if (y<-600) y=-600;
	if (y>600) y=600;
	x+=600; y+=600;
	int rez=0;
	for (int i=x;i>=0;i=(i&(i+1))-1)
		for (int j=y;j>=0;j=(j&(j+1))-1)
			rez+=a[i][j];
	return rez;
}
inline int sum(int x1,int y1,int x2,int y2)
{
	return sum(x2,y2)-sum(x1-1,y2)-sum(x2,y1-1)+sum(x1-1,y1-1);
}
void addSoldier(int x,int y,int s)
{
	w[s]=make_pair(x+y+1000000,x-y+1000000);
	add(x+y,x-y,1);
}
int removeSoldier(int s)
{
	if (w[s].first==0) return 0;
	add(w[s].first-1000000,w[s].second-1000000,-1);
	w[s].first=w[s].second=0;
	return 1;
}
int query(int x,int y,int d)
{
	return sum(x+y-d,x-y-d,x+y+d,x-y+d);
}
