/* GCC */
#include <algorithm>

#include <iostream>

using namespace std;

int scoord[50000][2];

unsigned short int A[4100][4100];

bool f=true;

void Init(){

    for(int i=0; i<50000; i++)scoord[i][0]=-1;

    f=false;

}

void AddY(int vx, int v, int l, int r, int y, int z){

    if(y<l) return;

    if(y>r) return;

    A[vx][v]+=z;

    if(l==r) return;

    int m=(l+r)/2;

    AddY(vx, 2*v, l, m, y, z);

    AddY(vx, 2*v+1, m+1, r, y, z);

}

void AddX(int v, int l, int r, int x, int y, int z){

    if(x<l) return;

    if(x>r) return;

    AddY(v, 1, 0, 1200, y, z);

    if(l==r) return;

    int m=(l+r)/2;

    AddX(2*v, l, m, x, y, z);

    AddX(2*v+1, m+1, r, x, y, z);

}

int CountY(int vx, int v, int l, int r, int y1, int y2){

    if(y1>r) return 0;

    if(y2<l) return 0;

    if(y1>=r && l>=y2) return A[vx][v];

    int m=(r+l)/2;

    return CountY(vx, 2*v, l, m, y1, y2)+CountY(vx, 2*v+1, m+1, r, y1, y2);

}

int CountX(int v, int l, int r, int x1, int x2, int y1, int y2){

    if(x1>r) return 0;

    if(x2<l) return 0;

    if(x1>=r && l>=x2) CountY(v, 1, 0, 1200, y1, y2);

    int m=(r+l)/2;

    return CountX(2*v, l, m, x1, x2, y1, y2)+CountX(2*v+1, m+1, r, x1, x2, y1, y2);

}

void addSoldier(int x,int y,int s){

    if(f) Init();

    s--;

    AddX(1, 0, 1200, x-y+600, x+y+600, 1);

}

int removeSoldier(int s){

    if(f) Init();

    s--;

    if(scoord[s][0]==-1) return 0;

    int rsx=scoord[s][0]-scoord[s][1]+600, rsy=scoord[s][0]+scoord[s][1]+600;

    AddX(1, 0, 1200, rsx, rsy, -1);

    return 1;

}

int query(int x,int y,int d){

    if(f) Init();

    return CountX(1, 0, 1200, x-y+600-d, x-y+600+d, x+y+600-d, x+y+600+d);

}
