/* GCC */

#include <utility>
using namespace std;

#define SZ 1201

pair <int, int> was[50001];
int fenvick[SZ][SZ];

const int Offset = 200000;

inline int f(int x)
{
    return x & (x+1);
}


void check_bounds(int& x, int& y)
{
    if (x < -600)
        x = -600;
    if (y < -600)
        y = -600;
    if (x > 600)
        x = 600;
    if (y < -600)
        y = -600;
    if (y > 600)
        y = 600;
}

int get_sum(int x,int y)
{
    check_bounds(x, y);
    x += 600;
    y += 600;
    int res = 0;

    for (int i = x; i >= 0; i = f(i) - 1) {
        for (int j = y; j >= 0; j = f(j) - 1) {
            res += fenvick[i][j];
        }
    }
    return res;
}

int get_sum(int x1, int y1, int x2, int y2)
{
    return get_sum(x1 - 1, y1 - 1) + get_sum(x2, y2) - get_sum(x1 - 1, y2) - get_sum(x2, y1 - 1);
}

void inc(int x,int y,int number)
{
    x += 600;
    y += 600;
    for (int i = x; i < SZ; i |= (i+1)) {
        for (int j = y; j < SZ; j |= (j+1)) {
            fenvick[i][j] += number;
        }
    }
}

void addSoldier(int x,int y,int s)
{
    was[s] = make_pair(x + y + Offset, x - y + Offset);
    inc(x + y, x - y, 1);
}

int removeSoldier(int s)
{
    if (was[s].first == 0)
        return 0;
    inc(was[s].first - Offset, was[s].second - Offset, -1);
    was[s].first = was[s].second = 0;
    return 1;
}

int query(int x,int y,int d)
{
    return get_sum(x + y - d, x - y - d, x + y + d,x - y + d);
}
