/* GCC */
#include <fstream>

using namespace std;
size_t n, t, tmp, g[51][51] = {}, mt[51] = {}, mx_lesson(0), ans[51][51] = {}, les_step[51] = {}, clas_step[51] = {};
bool used[51], fail = false;

bool try_kuhn(size_t v)
{
    if(used[v])
        return false;
    used[v] = true;
    for(size_t i = 1; i <= mx_lesson; ++i)
        if(g[v][i] && (mt[i] == 0 || try_kuhn(mt[i])))
        {
            mt[i] = v;
            return true;
        }
    return false;
}

int main(void)
{
    ifstream in("schedule.in");
    in >> n >> t;
    for(size_t i = 1; i <= n; ++i)
        for(size_t j = 1; j <= t; ++j)
        {
            in >> tmp;
            if(tmp > mx_lesson)
                mx_lesson = tmp;
            ++g[i][tmp], ++les_step[tmp], ++clas_step[i];
        }
    in.close();
    for(size_t l = 1; l <= t; ++l)
    {
        for(size_t i = 1; i <= n; ++i)
            used[i] = false;
        for(size_t i = 1; i <= mx_lesson; ++i)
            if(les_step[i] == t-l+1)
            {
                for(size_t clas = 1; clas <= n; ++clas)
                    if(!used[clas] && g[clas][i])
                    {
                        mt[i] = clas;
                        if(clas_step[mt[i]] == t-l+1)
                        {
                            bool f = true;
                            for(size_t cl = 1; cl <= n; ++cl)
                            {
                                tmp = 0;
                                for(size_t j = 1; j <= mx_lesson; ++j)
                                    if(g[cl][j])
                                        ++tmp;
                                if(tmp == 1 && g[cl][i])
                                {
                                    f = false;
                                    break;
                                }
                            }
                            if(f)
                                break;
                        }
                    }
                used[mt[i]] = true;
            }
            else if(les_step[i] > t-l+1)
            {
                fail = true;
                break;
            }
        if(fail)
            break;
        for(size_t i = 1; i <= n; ++i)
            try_kuhn(i);
        for(size_t i = 1; i <= mx_lesson; ++i)
            if(mt[i] != 0)
            {
                ans[mt[i]][l] = i, --g[mt[i]][i], --les_step[i], --clas_step[mt[i]];
                mt[i] = 0;
            }
    }
    ofstream out("schedule.out");
    if(fail)
        out << "-1\n";
    else
        for(size_t i = 1; i <= n; ++i)
        {
            for(size_t j = 1; j < t; ++j)
                out << ans[i][j] << ' ';
            out << ans[i][t] << '\n';
        }
    out.close();
    return 0;
}
